
package de.ivu.elect.business.wahlvorschlag.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag;

@RequestScoped
@Named(WahlvorschlagConversationSelect.COMPONENT_NAME)
public class WahlvorschlagConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wahlvorschlagConversationSelect";

  @Inject
  protected transient WahlvorschlagExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(WahlvorschlagConversationStore.class)
  protected transient WahlvorschlagConversationStore conversationStore;

  public WahlvorschlagConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public Wahlvorschlag getEntity() {
    return getEntityInternal();
  }

  private Wahlvorschlag getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(Wahlvorschlag entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.wahlvorschlag.entity.WahlvorschlagPK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(Wahlvorschlag entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.wahlvorschlag.entity.WahlvorschlagPK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.wahlvorschlag.entity.WahlvorschlagPK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected Wahlvorschlag attach(Wahlvorschlag entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected Wahlvorschlag attach( de.ivu.elect.business.wahlvorschlag.entity.WahlvorschlagPK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
